#include <stdio.h>
#include <process.h>
#include <windows.h>

#define COUNT 20
int g_Array[COUNT];

HANDLE hEvent, hWorkEvent;

void WorkProc(void *pData)
{
    volatile int value = *(int *)pData;

    while(1)
    {
        WaitForSingleObject(hEvent, INFINITE);
    
        for(int i = 0; i < COUNT; i++)
        {
            g_Array[i] = value;
        }
        
        SetEvent(hWorkEvent);
    }
}

int main()
{
    int first  = 1;
    int second = 2;
    
    hEvent     = CreateEvent(NULL, FALSE, TRUE, NULL);
    hWorkEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
    
    _beginthread(WorkProc, 0, &first);
    _beginthread(WorkProc, 0, &second);
    
    while(1)
    {
        WaitForSingleObject(hWorkEvent, INFINITE);
    
        for(int i = 0; i < COUNT; i++)
        {
            printf("%d ", g_Array[i]);
        }
        
        printf("\n");
        
        SetEvent(hEvent);
        
        Sleep(250);
    }
}

// 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2
// 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
// 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2
// 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
// 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2
// 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
// 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2
// 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
// 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2
// 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1